--- loncom/lonsql	2004/05/11 20:03:05	1.59
+++ loncom/lonsql	2006/02/07 05:08:27	1.70
@@ -3,7 +3,7 @@
 # The LearningOnline Network
 # lonsql - LON TCP-MySQL-Server Daemon for handling database requests.
 #
-# $Id: lonsql,v 1.59 2004/05/11 20:03:05 albertel Exp $
+# $Id: lonsql,v 1.70 2006/02/07 05:08:27 raeburn Exp $
 #
 # Copyright Michigan State University Board of Trustees
 #
@@ -115,6 +115,7 @@ use Fcntl;
 use Tie::RefHash;
 use DBI;
 use File::Find;
+use localenroll;
 
 ########################################################
 ########################################################
@@ -205,6 +206,23 @@ my $run =0;              # running count
 my $perlvarref=LONCAPA::Configuration::read_conf('loncapa.conf');
 my %perlvar=%{$perlvarref};
 #
+# Write the /home/www/.my.cnf file 
+my $conf_file = '/home/www/.my.cnf';
+if (! -e $conf_file) {
+    if (open MYCNF, ">$conf_file") {
+        print MYCNF <<"ENDMYCNF";
+[client]
+user=www
+password=$perlvar{'lonSqlAccess'}
+ENDMYCNF
+        close MYCNF;
+    } else {
+        warn "Unable to write $conf_file, continuing";
+    }
+}
+
+
+#
 # Make sure that database can be accessed
 #
 my $dbh;
@@ -223,6 +241,7 @@ unless ($dbh = DBI->connect("DBI:mysql:l
 
     exit 1;
 } else {
+    unlink('/home/httpd/html/lon-status/mysql.txt');
     $dbh->disconnect;
 }
 
@@ -240,20 +259,18 @@ if (-e $pidfile) {
 #
 # Read hosts file
 #
-my %hostip;
 my $thisserver;
 my $PREFORK=4; # number of children to maintain, at least four spare
 open (CONFIG,"$perlvar{'lonTabDir'}/hosts.tab") || die "Can't read host file";
 while (my $configline=<CONFIG>) {
-    my ($id,$domain,$role,$name,$ip)=split(/:/,$configline);
-    chomp($ip);
-    $hostip{$ip}=$id;
+    my ($id,$domain,$role,$name)=split(/:/,$configline);
+    $name=~s/\s//g;
     $thisserver=$name if ($id eq $perlvar{'lonHostID'});
-    $PREFORK++;
+    #$PREFORK++;
 }
 close(CONFIG);
 #
-$PREFORK=int($PREFORK/4);
+#$PREFORK=int($PREFORK/4);
 
 #
 # Create a socket to talk to lond
@@ -381,7 +398,7 @@ sub make_new_child {
 	    $queryid .= $run;
 	    print $client "$queryid\n";
 	    #
-	    &logthis("QUERY: $query - $arg1 - $arg2 - $arg3");
+	    # &logthis("QUERY: $query - $arg1 - $arg2 - $arg3");
 	    sleep 1;
             #
             my $result='';
@@ -406,6 +423,43 @@ sub make_new_child {
                     $result='no_such_file';
                 }
                 # end of log query
+            } elsif (($query eq 'fetchenrollment') || 
+                                           ($query eq 'institutionalphotos')) {
+                # retrieve institutional class lists
+                my $dom = &unescape($arg1);
+                my %affiliates = ();
+                my %replies = ();
+                my $locresult = '';
+                my $querystr = &unescape($arg3);
+                foreach (split/%%/,$querystr) {
+                    if (/^([^=]+)=([^=]+)$/) {
+                        @{$affiliates{$1}} = split/,/,$2;
+                    }
+                }
+                if ($query eq 'fetchenrollment') { 
+                    $locresult = &localenroll::fetch_enrollment($dom,\%affiliates,\%replies);
+                } elsif ($query eq 'institutionalphotos') {
+                    my $crs = &unescape($arg2);
+                    $locresult = &localenroll::institutional_photos($dom,$crs,\%affiliates,\%replies,'update');
+                }
+                $result = &escape($locresult.':');
+                if ($locresult) {
+                    $result .= &escape(join(':',map{$_.'='.$replies{$_}} keys %replies));
+                }
+            } elsif ($query eq 'prepare activity log') {
+                my ($cid,$domain) = map {&unescape($_);} ($arg1,$arg2);
+                &logthis('preparing activity log tables for '.$cid);
+                my $command = 
+                    qq{$perlvar{'lonDaemons'}/parse_activity_log.pl -course=$cid -domain=$domain};
+                system($command);
+                &logthis($command);
+                my $returnvalue = $?>>8;
+                if ($returnvalue) {
+                    $result = 'error: parse_activity_log.pl returned '.
+                        $returnvalue;
+                } else {
+                    $result = 'success';
+                }
             } else {
                 # Do an sql query
                 $result = &do_sql_query($query,$arg1,$arg2);
@@ -413,8 +467,6 @@ sub make_new_child {
             # result does not need to be escaped because it has already been
             # escaped.
             #$result=&escape($result);
-            # reply with result, append \n unless already there
-	    $result.="\n" unless ($result=~/\n$/);
             &reply("queryreply:$queryid:$result",$conserver);
         }
         # tidy up gracefully and finish
@@ -462,6 +514,7 @@ sub process_file {
 
 sub do_sql_query {
     my ($query,$custom,$customshow) = @_;
+#    &logthis('doing query '.$query);
     $custom     = &unescape($custom);
     $customshow = &unescape($customshow);
     #